/* csample1.c:  C-COMPILER-51 Sample Program */
/* Copyright KEIL ELEKTRONIK GmbH, 1988      */

#include <reg51.h>                             /* define 8051 registers */
#include <nc\stdio.h"                             /* define I/O functions */
#include "c:\utili\procesad\c51v4\inc\math.h"
#include "c:\utili\procesad\c51v4\inc\intrins.h"
#define PIa 6.283185307
#define PIb 12.56637061
void inicia_puerto();
float calcula(float,float);
float ecua(float ecu,float ratio);
int t_carga(float);

 
main ()  {                                     /* main program */
  float ratio, toleran, result;                /* define operation registers */
  int fin;
  unsigned int finh,finl;
  
  //bit operation;                               /* define operation */

  inicia_puerto();
  printf ("\ntolerancia: ");scanf("%f",&toleran);printf("\n%f\n",toleran);
  while(1){
  printf ("\nratio : ");scanf("%f",&ratio);printf("\n%f\n",ratio);
  result=calcula(ratio,toleran);  
  printf("resul:%f",result);
  fin=t_carga(result);
  printf("\nfin %d ",fin);
  
  finl=(unsigned int)(fin & 0x00FF);
  finh=((_iror_((unsigned int)fin,8))& 0x00FF);
  //finh=(unsigned int)(fin & 0x00FF);
  printf("\nfinh %2X finl %2X",finh,finl);

  }

 }

void inicia_puerto()
{
  SCON = 0x52;    /* SCON */                   /* setup serial port control */
  TMOD = 0x20;    /* TMOD */                   /* hardware (2400 BAUD @12MHZ) */
  TCON = 0x69;    /* TCON */
  TH1 =  0xf3;    /* TH1 */

}

float calcula(float ratio,float toleran)
{
    float ant,actual;    
    float aux,aux2;
    ratio=ratio/100;
    actual=0;
        do
        {
                
                ant=actual;
                actual=ecua(ant,ratio);
                aux=fabs(actual-ant);
                aux2=fabs(1-2.0*actual+(sin(PIb*actual))/PIa-ratio);
                printf("\n actual %3.3g anterior %3.3g\n aux %3.3g\n  aux2 %3.3g\n ",actual,ant,aux,aux2);
                 
        }
       while((aux>toleran) || (aux2>toleran));

    return actual;
}



float ecua(float ecu,float ratio)
{
  float c;
  c=(0.5-ratio*0.5+(sin(PIb*ecu))/(PIb));
  printf("\n valor de c:%3.3g",c);
  return(c);

}

int t_carga(float p)
{
        printf("\numero ciclos %f\n",p);        
        return(65536-(p*20*1000*11.0592/12));

                

                  
}





